'use strict';

var getPackageJson = function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
        var data;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return _fs2.default.readFileAsync('./package.json', { encoding: 'utf-8' });

                    case 2:
                        data = _context.sent;
                        return _context.abrupt('return', JSON.parse(data));

                    case 4:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function getPackageJson() {
        return ref.apply(this, arguments);
    };
}();

var main = function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
        var conf, info, _info,

        // TODO: if "info" contains a "repository", guess where to create repo to match it
        name, description, createRepo, data;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        conf = (0, _rc2.default)('cgr', {}, argv);
                        info = argv;

                        if (!(info.name == null || info.name === '')) {
                            _context2.next = 6;
                            break;
                        }

                        _context2.next = 5;
                        return getPackageJson();

                    case 5:
                        info = _context2.sent;

                    case 6:
                        _info = info;
                        name = _info.name;
                        description = _info.description;


                        console.log('Creating repository ' + name + ' (' + description + ')');

                        createRepo = (0, _github2.default)(conf);
                        _context2.next = 13;
                        return (0, _index2.default)({ name: name, description: description }, createRepo);

                    case 13:
                        data = _context2.sent;


                        console.log('Created repository at "' + data.url + '".');

                        _context2.next = 17;
                        return (0, _saveRepoHandlers.maybeSavePackageJson)(data);

                    case 17:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));

    return function main() {
        return ref.apply(this, arguments);
    };
}();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _rc = require('rc');

var _rc2 = _interopRequireDefault(_rc);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _github = require('./github');

var _github2 = _interopRequireDefault(_github);

var _saveRepoHandlers = require('./save-repo-handlers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _bluebird2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _bluebird2.default.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

_bluebird2.default.longStackTraces();
_bluebird2.default.promisifyAll(_fs2.default);

var argv = _yargs2.default.alias('t', 'token').alias('n', 'name').alias('desc', 'description').alias('d', 'description').argv;

_bluebird2.default.resolve(main()).done();