'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.maybeSavePackageJson = undefined;

var maybeSavePackageJson = exports.maybeSavePackageJson = function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(repoData) {
        var obj, newJson;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.prev = 0;
                        _context.next = 3;
                        return _fs2.default.accessAsync('./package.json', _fs2.default.F_OK);

                    case 3:
                        _context.next = 9;
                        break;

                    case 5:
                        _context.prev = 5;
                        _context.t0 = _context['catch'](0);

                        // file does not exist!!
                        console.error(_context.t0);
                        return _context.abrupt('return');

                    case 9:
                        _context.t1 = JSON;
                        _context.next = 12;
                        return _fs2.default.readFileAsync('./package.json', { encoding: 'utf-8' });

                    case 12:
                        _context.t2 = _context.sent;
                        obj = _context.t1.parse.call(_context.t1, _context.t2);


                        obj.repository = {
                            type: 'git',
                            url: repoData.url
                        };

                        newJson = JSON.stringify(obj, null, '  ');
                        _context.next = 18;
                        return _fs2.default.writeFileAsync('./package.json', newJson, { encoding: 'utf-8' });

                    case 18:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[0, 5]]);
    }));

    return function maybeSavePackageJson(_x) {
        return ref.apply(this, arguments);
    };
}();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _bluebird2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _bluebird2.default.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

// to really make sure there are promisified versions both here and in cli.js
// by adding this, we can rely less on how functions and imports are hoisted
_bluebird2.default.promisifyAll(_fs2.default);