'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _child_process = require('child_process');

var child_process = _interopRequireWildcard(_child_process);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _bluebird2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _bluebird2.default.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

_bluebird2.default.promisifyAll(child_process);

function exec(cmd) {
    console.log('>>', cmd);
    return child_process.execAsync(cmd);
}

exports.default = function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(info, createRepo, opts) {
        var remoteName, branch, res;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        opts = opts || {};
                        remoteName = opts.remoteName || 'origin';
                        branch = opts.branch || 'master';
                        _context.next = 5;
                        return exec('git init');

                    case 5:
                        _context.next = 7;
                        return createRepo(info);

                    case 7:
                        res = _context.sent;
                        _context.next = 10;
                        return exec('git remote add ' + remoteName + ' ' + res.upstreamUrl);

                    case 10:
                        _context.next = 12;
                        return exec('git push --set-upstream ' + remoteName + ' ' + branch);

                    case 12:
                        return _context.abrupt('return', res);

                    case 13:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    function setup(_x, _x2, _x3) {
        return ref.apply(this, arguments);
    }

    return setup;
}();